<i18n>
{
  "fr": {
    "title": "Les bâtiments",
    "info-1": "Définissez l'ensemble des bâtiments occupés par le laboratoire en",
    "info-2": "On ne considère que les parties de bâtiments dédiées aux activités de recherche et au service support du laboratoire. Par conséquent, les salles d’enseignement, par exemple, seront déduites de la surface utile brute occupée.",
    "info-3": "Les données de consommations affichées ci-dessous pour le chauffage et l’électricité tiennent compte de la part de la surface utile brute que vous avez saisie.",
    "no-buildings": "Aucun bâtiment",
    "delete-msg": "Êtes vous sûr de vouloir supprimer le batiment",
    "save-msg": "Les informations de bâtiments ont été sauvegardées avec <strong><span style='color:green;'>succès</span></strong>.",
    "useful-area": "Surface utile brute",
    "perc-area": "Part de la SUB",
    "site": "Site"
  },
  "en": {
    "title": "Buildings",
    "info-1": "Define all the buildings occupied by the laboratory in",
    "info-2": "We only consider the spaces of the building that are dedicated to the research activities and to the research support services of the laboratory. Consequently teaching spaces, for example, must be subtracted from the gross useful area occupied. ",
    "info-3": "The consumption data posted below for heating and electricity account for the share of the gross useful area that you have entered. ",
    "no-buildings": "No building",
    "delete-msg": "Are you sure that you want to delete the building ?",
    "save-msg": "The buildings data have been <strong><span style='color:green;'>successfully</span></strong>saved.",
    "useful-area": "Gross useful area",
    "perc-area": "Share of the gross useful area",
    "site": "Site"
  }
}
</i18n>

<template>
  <div>
    <serveur-info :erreur="module.erreur"/>
    <su-service :icon="'building'">
      <template #title>
        {{ $t('title') }}
      </template>
      <p>
        {{ $t('info-1') }} <strong>{{ GHGIyear }}</strong>.
        <br />
        <br />
        {{ $t('info-2') }}
        <br />
        {{ $t('info-3') }}
      </p>
    </su-service>
    <br />
    <b-table
      :data="buildings"
      :striped="true"
      :narrowed="true"
      :hoverable="true"
      :sort-icon="'angle-up'"
      default-sort="name"
    >
      <b-table-column
        v-if="sites.length > 0"
        :label="$t('site')"
        field="site"
        sortable
        v-slot="props"
      >
        {{ props.row.site }}
      </b-table-column>
      <b-table-column
        :label="$t('id')"
        field="name"
        sortable
        v-slot="props"
      >
        {{ props.row.name }}
      </b-table-column>
      <b-table-column
        :label="$t('useful-area')"
        field="area"
        sortable
        numeric
        v-slot="props"
      >
        {{ props.row.area }} m2
      </b-table-column>
      <b-table-column
        :label="$t('perc-area')"
        field="share"
        sortable
        numeric
        v-slot="props"
      >
        {{ props.row.share }}
      </b-table-column>
      <b-table-column
        :label="$t('heating')"
        field="heating"
        sortable
        numeric
        v-slot="props"
      >
        {{ props.row.getTotalHeatingConsumption() | splitNumber }}

      </b-table-column>
      <b-table-column
        :label="$t('electricity')"
        field="electricity"
        sortable
        numeric
        v-slot="props"
      >
        {{ Math.round(props.row.getElectricityConsumption()) | splitNumber }}
      </b-table-column>
      <b-table-column
        :label="$t('refrigerants')"
        field="refrigerants"
        sortable
        numeric
        v-slot="props"
      >
        {{ props.row | getGasList }}
      </b-table-column>
      <b-table-column v-slot="props">
        <div class="panel-block">
          <b-tooltip
            v-if="submitted"
            :label="$t('display')"
            type="is-black"
          >
            <b-button
              size="is-small"
              icon-left="search"
              @click="edit(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            v-else
            :label="$t('edit')"
            type="is-black"
          >
            <b-button
              size="is-small"
              icon-left="pencil"
              @click="edit(props.row)"
            />
          </b-tooltip>
          <b-tooltip
            :label="$t('delete')"
            type="is-black"
          >
            <b-button
              size="is-small"
              :disabled="submitted"
              icon-left="trash"
              @click="del(props.row)"
            />
          </b-tooltip>
        </div>
      </b-table-column>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px;"></i>
          </p>
          <p>{{ $t('no-buildings') }}</p>
        </div>
      </section>
    </b-table>
    <building-modal
      v-if="building!==null"
      :displayModal="displayModal"
      :building="building"
      :buildings="buildings"
      :modeCreation="modeCreation"
      @close="closeModal"
      @update="update"
      @add="add"
    />
    <br />
    <nav class="level">
      <div class="level-left"></div>
      <div class="level-right">
        <div class="buttons">
          <b-button
            class="button"
            icon-left="plus"
            :disabled="submitted"
            @click="displayAddForm()"
          >
            {{ $t('add') }}
          </b-button>
          <b-button
            class="level-item"
            :icon-left="validSavedIcon"
            :disabled="!module.isModified"
            type="is-primary"
            @click="valider()"
          >
            <span v-if="isAuthenticated">{{ $t('save') }}</span>
            <span v-else>{{ $t('validate') }}</span>
          </b-button>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import Building from '@/models/carbon/Building.js'
import { mapGetters } from 'vuex'

export default {
  name: 'Buildings',
  components: {
    'su-service': () => import('@/components/SUService.vue'),
    'serveur-info': () => import('@/components/ServeurInfo.vue'),
    'building-modal': () => import('@/components/carbon/forms/BuildingModal.vue')
  },
  $_veeValidate: {
    validator: 'new'
  },
  data () {
    return {
      modeCreation: false,
      displayModal: false,
      building: null
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    validSavedIcon: function () {
      let icon = null
      if (this.isAuthenticated) {
        icon = 'save'
      } else {
        icon = 'check'
      }
      return icon
    },
    submitted: function () {
      return this.$store.getters['ghgi/item']['buildingsSubmitted']
    },
    GHGIyear: function () {
      return this.$store.getters['ghgi/item']['year']
    },
    buildings: function () {
      return this.$store.getters['buildings/items']
    },
    module: function () {
      return this.$store.getters['buildings/module']
    },
    laboratory: function () {
      return this.$store.getters['api/laboratory']
    },
    sites: function () {
      if ('sites' in this.laboratory) {
        return this.laboratory.sites
      } else {
        return []
      }
    },
    mainSite: function () {
      if ('mainSite' in this.laboratory) {
        return this.laboratory.mainSite
      } else {
        return ''
      }
    }
  },
  filters: {
    getGasList: function (building) {
      let gasList = ''
      for (let gas of building.refrigerants) {
        gasList += gas.name.toUpperCase() + ' (' + gas.total + ' kg), '
      }
      if (gasList !== '') {
        gasList = gasList.substring(0, gasList.length - 2)
      } else {
        gasList = '0'
      }
      return gasList
    }
  },
  methods: {
    valider: function () {
      if (this.isAuthenticated) {
        const loadingComponent = this.$buefy.loading.open({
          container: null
        })
        this.$store.dispatch('buildings/save')
          .then(data => {
            loadingComponent.close()
            this.$store.commit('buildings/ERREUR', '')
            this.$store.commit('buildings/ISMODIFIED', false)
            if (this.buildings.length === 0) {
              this.$store.commit('buildings/ISVALID', false)
            } else {
              this.$store.commit('buildings/ISVALID', true)
            }
            window.scrollTo(0, 0)
            this.$buefy.toast.open({
              type: 'is-light',
              message: this.$t('save-msg')
            })
          })
          .catch((erreur) => {
            loadingComponent.close()
            this.$store.commit('buildings/ERREUR', erreur.response.data)
            this.$store.commit('buildings/ISVALID', false)
          })
      } else {
        if (this.buildings.length === 0) {
          this.$store.commit('buildings/ISVALID', false)
        } else {
          this.$store.commit('buildings/ISVALID', true)
        }
        this.$store.commit('buildings/ISMODIFIED', false)
      }
    },
    displayAddForm: function () {
      this.modeCreation = true
      this.building = new Building(
        null, '', 0, 100, [{
          id: null,
          type: null,
          urbanNetwork: null,
          january: 0,
          february: 0,
          march: 0,
          april: 0,
          may: 0,
          june: 0,
          july: 0,
          august: 0,
          septembre: 0,
          octobre: 0,
          novembre: 0,
          decembre: 0,
          total: 0,
          isMonthly: true,
          isOwnedByLab: false
        }], [], {
          id: null,
          january: 0,
          february: 0,
          march: 0,
          april: 0,
          may: 0,
          june: 0,
          july: 0,
          august: 0,
          septembre: 0,
          octobre: 0,
          novembre: 0,
          decembre: 0,
          total: 0,
          isMonthly: true
        }, false, 0, this.mainSite
      )
      this.displayModal = true
    },
    closeModal: function () {
      this.displayModal = false
      this.building = null
    },
    add: function (building) {
      this.$store.dispatch('buildings/add', building)
      this.$store.commit('buildings/ISMODIFIED', true)
      this.closeModal()
    },
    update: function (obj) {
      this.$store.dispatch('buildings/update', obj)
      this.$store.commit('buildings/ISMODIFIED', true)
      this.closeModal()
    },
    edit: function (building) {
      this.modeCreation = false
      this.building = building
      this.displayModal = true
    },
    del: function (building) {
      let self = this
      this.$buefy.dialog.confirm({
        title: self.$t('delete') + ' "' + building.name + '"',
        message: self.$t('delete-msg') + ' <b>' + building.name + '</b>?',
        confirmText: self.$t('validate'),
        cancelText: self.$t('cancel'),
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          self.$store.dispatch('buildings/delete', building)
          self.$store.commit('buildings/ISMODIFIED', true)
        }
      })
    }
  }
}
</script>

<style>
.b-tabs .tabs {
  overflow: visible;
}
.b-tabs .tabs li.is-disabled {
  pointer-events: auto;
}
.b-tabs .tabs li.is-disabled a:active {
  pointer-events: none;
}
span.heating-header {
  margin-right: 15px;
}
.table td {
  vertical-align: middle !important;
}
</style>
